    001/*
    002    Licensed to the Apache Software Foundation (ASF) under one
    003    or more contributor license agreements.  See the NOTICE file
    004    distributed with this work for additional information
    005    regarding copyright ownership.  The ASF licenses this file
    006    to you under the Apache License, Version 2.0 (the
    007    "License"); you may not use this file except in compliance
    008    with the License.  You may obtain a copy of the License at
    009
    010       http://www.apache.org/licenses/LICENSE-2.0
    011
    012    Unless required by applicable law or agreed to in writing,
    013    software distributed under the License is distributed on an
    014    "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    015    KIND, either express or implied.  See the License for the
    016    specific language governing permissions and limitations
    017    under the License.
    018 */
    019package org.apache.wiki.htmltowiki.syntax;
    020
    021import org.apache.wiki.htmltowiki.XHtmlElementToWikiTranslator;
    022import org.jdom2.Element;
    023import org.jdom2.JDOMException;
    024
    025import java.io.PrintWriter;
    026import java.util.Deque;
    027
    028
    029/**
    030 * Translates to wiki syntax from a {@code CODE} element.
    031 */
    032public abstract class CodeDecorator {
    033
    034    final protected PrintWriter out;
    035    final protected Deque< String > preStack;
    036    final protected XHtmlElementToWikiTranslator chain;
    037
    038    protected CodeDecorator( final PrintWriter out, final Deque< String > preStack, final XHtmlElementToWikiTranslator chain ) {
    039        this.out = out;
    040        this.preStack = preStack;
    041        this.chain = chain;
    042    }
    043
    044    /**
    045     * Translates the given XHTML element into wiki markup.
    046     *
    047     * @param e XHTML element being translated.
    048     */
    049    public void decorate( final Element e ) throws JDOMException {
    050        out.print( markupCodeOpen() );
    051        preStack.addFirst( markupCodeOpen() );
    052        chain.translate( e );
    053        preStack.removeFirst();
    054        out.print( markupCodeClose() );
    055        // NOTE: don't print a newline after the closing brackets because if the Text is inside
    056        // a table or list, it would break it if there was a subsequent row or list item.
    057    }
    058
    059    /**
    060     * Opening wiki markup for a {@code CODE} element.
    061     *
    062     * @return Opening wiki markup for a {@code CODE} element.
    063     */
    064    protected abstract String markupCodeOpen();
    065
    066    /**
    067     * Closing wiki markup for a {@code CODE} element.
    068     *
    069     * @return Closing wiki markup for a {@code CODE} element.
    070     */
    071    protected abstract String markupCodeClose();
    072
    073}